<template>
  <q-layout view="hHh lpR fFf">

    <q-header elevated class="bg-primary text-white">
      <q-toolbar>
        <q-toolbar-title>
          <q-avatar>
            <img src="~assets/bch.svg">
          </q-avatar>
          <router-link to="/">ScanToPay.Cash</router-link>
        </q-toolbar-title>
      </q-toolbar>
    </q-header>

    <q-page-container>
      <q-page class="flex flex-center">
        <div class="column q-gutter-md">
          <q-btn color="white" text-color="black" size="lg" icon="add" label="Create new Terminal" :to="`/setup/${generateShortId()}`" />
          <q-btn color="white" text-color="black" size="lg" icon="qr_code_scanner" label="Scan Terminal Code" @click="scanTerminalCode" />
        </div>
      </q-page>
    </q-page-container>

  </q-layout>
</template>

<script setup lang="ts">
import { onMounted } from 'vue'
import { useRouter } from 'vue-router'
import { useQuasar } from 'quasar'

import { generateShortId } from '../lib/utils'

// Import a simple key-value storage that uses the IndexedDB feature of modern browsers.
import { get, set, del, clear, entries } from 'idb-keyval'

const $q = useQuasar()
const $router = useRouter()

function scanTerminalCode () {
  $q.notify({ type: 'warning', message: 'This feature has not been implemented yet.' })
}

//-----------------------------------------------------------------------------
// Hooks
//-----------------------------------------------------------------------------

onMounted(async (): Promise<void> => {
  const lastUsedTerminalId = await get('lastUsedTerminalId')
  const lastUsedTerminalPassword = await get('lastUsedTerminalPassword')

  if (lastUsedTerminalId) {
    $router.push(`/t/${lastUsedTerminalId}/${lastUsedTerminalPassword}`)
  }
})

</script>
